import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.HttpVersion;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.mime.MultipartEntity;
import org.apache.http.entity.mime.content.FileBody;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.CoreProtocolPNames;
import org.apache.http.util.EntityUtils;


public class PyElogAPI
{

    public static void main(String[] args) throws Exception
    {
        // select files
        File ontology = new File("examples/elog/jaguar.owl");
        // File ontology = new File("examples/elog/tiger.owl");

        String id = startElogFile(ontology);

        String state = PyExecutor.getAction(id, "state");
        while(state.startsWith("wating")) {
            Thread.currentThread();
            Thread.sleep(2500);
            state = PyExecutor.getAction(id, "state");
            System.out.println(state);
        }
        int position = 0;
        while(state.equals("running")) {
            Thread.currentThread();
            Thread.sleep(2500);
            String log = PyExecutor.getAction(id, "log");
            System.out.println(log.substring(position).trim());
            position = log.length();
            state = PyExecutor.getAction(id, "state");
        }
        System.out.println(state);

        if(state.equals("complete")) {
            // download file
            File out = new File("res" + System.getProperty("file.separator") + id + ".owl");
            if(!new File("res").exists()) {
                new File("res").mkdir();
            }
            System.out.println("Result saved to: " + PyExecutor.getResult(id, "rOutput", out));

            InputStream in = new FileInputStream(out);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));
            String line;
            while((line = br.readLine()) != null) {
                System.out.println(line);
            }
            in.close();

            System.out.println("\n=============================\nFinish => " + out.getAbsolutePath());
        }
    }


    private synchronized static String startElogFile(File ontology) throws Exception
    {
        HttpClient httpclient = new DefaultHttpClient();
        httpclient.getParams().setParameter(CoreProtocolPNames.PROTOCOL_VERSION, HttpVersion.HTTP_1_1);

        HttpPost httppost = new HttpPost(PyExecutor.server + "startELOG");

        // build entity:
        MultipartEntity mpEntity = new MultipartEntity();
        mpEntity.addPart("ontology", new FileBody(ontology, "multipart"));
        httppost.setEntity(mpEntity);

        System.out.println("executing request " + httppost.getRequestLine());
        HttpResponse response = httpclient.execute(httppost);
        HttpEntity resEntity = response.getEntity();

        System.out.println("status: " + response.getStatusLine());
        String result = null;
        if(resEntity != null) {
            result = EntityUtils.toString(resEntity);
            System.out.println("ID " + result);
            EntityUtils.consume(resEntity);
        }
        httpclient.getConnectionManager().shutdown();
        return result;
    }
}
