import eu.sealsproject.platform.repos.tdrs.client.TestCaseIterator;
import eu.sealsproject.platform.repos.tdrs.client.TestDataSuite;


public class SealsTDRSExample
{
    public static void main(String[] args)
    {
        /*
         * 0 = anatomy
         * 1 = benchmark 1
         * 2 = conference
         * 3 = benchmark 2
         * 4 = benchmark 3
         * 5 = multifram de-fr
         */
        int track = 2;

        String SEALS_TDRS_URL = "http://seals.sti2.at/tdrs-web/";
        String testCollectionName = "";
        String testCollectionVersion = "";

        if(track > 2) {
            SEALS_TDRS_URL = "http://seals-test.sti2.at/tdrs-web/";
        }

        switch(track) {
            case 0:
                testCollectionName = "Anatomy Testsuite";
                testCollectionVersion = "2010";
            break;
            case 1:
                testCollectionName = "Benchmark Testsuite";
                testCollectionVersion = "2010full";
            break;
            case 2:
                testCollectionName = "Conference Testsuite";
                testCollectionVersion = "2010";
            break;
            case 3:
                // benchmark 2:
                testCollectionName = "b50cbebb-5be3-4fc6-a02d-3a801791770c";
                testCollectionVersion = "ebee3a34-a155-4d50-879f-33372822db4d";
            break;
            case 4:
                // benchmark 3:
                testCollectionName = "81a7f2d2-81fd-4a6d-b076-3adc7b3e0918";
                testCollectionVersion = "8372414c-0185-4ff0-921b-969620c04777";
            break;
            case 5:
                // multifarm
                testCollectionName = "de-fr-multifarm";
                testCollectionVersion = "de-fr-multifarm-v1.0";
            break;
        }

        while(true) {
            TestDataSuite tds = new TestDataSuite(SEALS_TDRS_URL, testCollectionName, testCollectionVersion);
            TestCaseIterator it = tds.getTestCases();

            while(it.hasNext()) {
                String testCaseId = it.next();
                System.out.println("testcase with id: " + testCaseId);

                System.out.println("\tcomponent source:    " + tds.getDataItem(testCaseId, "source"));
                System.out.println("\tcomponent target:    " + tds.getDataItem(testCaseId, "target"));
                System.out.println("\tcomponent reference: " + tds.getDataItem(testCaseId, "reference"));

                final String source = tds.getDataItem(testCaseId, "source").toExternalForm();
                final String target = tds.getDataItem(testCaseId, "target").toExternalForm();
                final String reference = tds.getDataItem(testCaseId, "reference").toExternalForm();

                Thread t = new Thread(new Runnable() {
                    public void run()
                    {
                        try {
                            PyCodiAPI.startCodiUrl(source, target, reference, "-1");
                        } catch(Exception e) {
                            e.printStackTrace();
                        }
                    }
                });
                t.start();
            }
        }
    }
}